=== debian/changelog ===
transmission (3.00-2ubuntu2) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 25 Mar 2022 10:52:54 +0100

transmission (3.00-2ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/openssl3-compat.patch: Compatibility with OpenSSL 3.
  * Dropped changes, included in Debian:
    - debian/patches/build_new_autoconf.patch: Fix FTBFS with autoconf
      2.70.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 29 Dec 2021 16:48:19 -0800

transmission (3.00-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since stretch:
    + Build-Depends: Drop versioned constraint on debhelper, intltool.

  [ Sandro Tosi ]
  * debian/patches/build_new_autoconf.patch
    - fix build with autoconf 2.70, patch by Sebastien Bacher; Closes: #978911
  * debian/control
    - bump Standards-Version to 4.6.0.1 (no changes needed)

 -- Sandro Tosi <morph@debian.org>  Sun, 19 Dec 2021 00:23:43 -0500

transmission (3.00-1ubuntu5) jammy; urgency=medium

  * debian/patches/openssl3-compat.patch: Compatibility with OpenSSL 3.
    Closes LP: #1946215.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 13 Dec 2021 14:47:31 -0800

transmission (3.00-1ubuntu4) jammy; urgency=medium

  * debian/patches/build_new_autoconf.patch: Fix FTBFS with autoconf
    2.70.  Thanks to Sebastien Bacher <seb128@ubuntu.com>.  Closes:
    #978911.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 09 Dec 2021 21:21:28 +0000

transmission (3.00-1ubuntu3) jammy; urgency=medium

  * No-change rebuild against libssl3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 09 Dec 2021 00:21:35 +0000

transmission (3.00-1ubuntu2) impish; urgency=medium

  * Revert the delta to not use ayatana indicators since those are promoted

 -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 18 Jun 2021 13:29:03 +0200

transmission (3.00-1) unstable; urgency=medium

  * New upstream release; Closes: #960362
    - fix CVE-2018-10756; Closes: #961461
  * debian/patches/*
    - refresh, drop patches
  * debian/copyright
    - update upstream copyright info
    - extend packaging copyright years
  * New location for doc files

 -- Sandro Tosi <morph@debian.org>  Thu, 28 May 2020 22:05:37 -0400

transmission (2.94-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field

  [ Sandro Tosi ]
  * debian/patches/patch-vendored-libdht.patch
    - patch DHT, as of 0.26 upstream release; Closes: #916705
  * debian/control
    - bump Standards-Version to 4.3.0 (no changes needed)

 -- Sandro Tosi <morph@debian.org>  Mon, 31 Dec 2018 18:07:49 -0500
